跳至主要内容

与 Vue 集成

提示

在阅读本文档之前,请先熟悉 Vue 的基本概念和模式。如需温习相关知识,请参阅 Vue 3 文档

DHTMLX To Do List 与 Vue 3 兼容。以下示例演示如何将两者结合使用。完整项目请参见 GitHub 示例

创建项目

使用脚手架工具创建新的 Vue 项目并安装依赖项。

信息

在创建新项目之前,请先安装 Node.js

要创建 Vue 项目,运行以下命令:

npm create vue@latest

该命令会安装并执行 create-vue,即 Vue 官方项目脚手架工具。详情请参阅 Vue.js 快速上手指南

将项目命名为 my-vue-todo-app

安装依赖项

进入应用目录:

cd my-vue-todo-app

使用包管理器安装依赖项并启动开发服务器。

使用 yarn 运行以下命令:

yarn
yarn start

使用 npm 运行以下命令:

npm install
npm run dev

应用将在本地地址上运行(例如 http://localhost:3000)。

创建 To Do List

停止应用并安装 To Do List 包。

步骤一:安装包

下载 To Do List 试用包 并按照 README 文件中的步骤操作。试用版仅可使用 30 天。

步骤二:创建组件

创建一个 Vue 组件,将带有 Toolbar 的 To Do List 添加到应用中。在 src/components/ 目录下,新建一个名为 ToDo.vue 的文件。

导入源文件

打开 ToDo.vue,导入 To Do List 的源文件。可选择以下两种导入路径之一:

  • 从本地文件夹安装的 PRO 版本 - 从 dhx-todolist-package 导入
  • 试用版 - 从 @dhx/trial-todolist 导入

以下示例从 PRO 包导入:

ToDo.vue
<script>
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
</script>

根据包的不同,源文件可能已被压缩。此时请将 CSS 文件导入为 todo.min.css

以下代码片段从试用包导入:

ToDo.vue
<script>
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import '@dhx/trial-todolist/dist/todo.css';
</script>

本教程使用试用版本。

设置容器并添加带 Toolbar 的 To Do List

要在页面上显示带 Toolbar 的 To Do List,需为两个组件创建容器并使用构造函数进行初始化。以下示例在 mounted() 钩子中初始化组件:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
mounted() {
// 初始化 To Do List 组件
this.todo = new ToDo(this.$refs.todo_container, {});

// 初始化 Toolbar 组件
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api, // 提供 To Do List 内部 API
// 其他配置属性
});
},

unmounted() {
this.todo.destructor(); // 销毁 To Do List
this.toolbar.destructor(); // 销毁 Toolbar
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

加载数据

src/ 目录下创建 data.js 文件并向其中添加数据。以下示例导出一个 getData() 函数,该函数返回任务、用户和项目数据:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

打开 App.vue,导入数据并通过内部 data() 方法进行初始化。将数据作为 props 传入 <ToDo/> 组件:

App.vue
<script>
import ToDo from "./components/ToDo.vue";
import { getData } from "./data";

export default {
components: { ToDo },
data() {
const { users, projects, tasks } = getData();
return {
users,
projects,
tasks
};
}
};
</script>

<template>
<ToDo :users="users" :tasks="tasks" :projects="projects" />
</template>

打开 ToDo.vue,将传入的 props 应用到 To Do List 配置对象。以下代码片段通过配置传入用户、任务和项目数据:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
props: ["tasks", "users", "projects"],

mounted() {
this.todo = new ToDo(this.$refs.todo_container, {
users: this.users,
tasks: this.tasks,
projects: this.projects,
// 其他配置属性
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api,
// 其他配置属性
});
},

unmounted() {
this.todo.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

您也可以在 mounted() 中使用 parse() 方法将数据加载到 To Do List。以下示例在初始化后使用 parse() 加载数据:

ToDo.vue
<script>
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default {
props: ["tasks", "users", "projects"],

mounted() {
this.todo = new ToDo(this.$refs.todo_container, {});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.todo.api,
// 其他配置属性
});

this.todo.parse({
users: this.users,
tasks: this.tasks,
projects: this.projects
});
},

unmounted() {
this.todo.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="todo_container" style="height: calc(100% - 56px);"></div>
</div>
</template>

每次调用 parse(data) 都会替换当前数据集。

该组件现在将渲染一个已填充数据的 To Do List。其他可用属性请参见配置概览

处理事件

订阅事件以响应用户操作。请参见完整事件列表

打开 ToDo.vue 并完善 mounted() 方法。以下代码片段为 add-task 事件添加处理程序:

ToDo.vue
<script>
// ...
export default {
// ...
mounted() {
this.todo = new ToDo(this.$refs.todo_container, {});

this.todo.api.on("add-task", ({ id }) => {
console.log("A new task is added", id);
});
},

unmounted() {
this.todo.destructor();
}
}
</script>

// ...

步骤三:将 To Do List 添加到应用中

要将组件添加到应用中,请打开 App.vue 并将默认代码替换为以下代码片段:

App.vue
<script>
import ToDo from "./components/ToDo.vue";
import { getData } from "./data";

export default {
components: { ToDo },
data() {
const { users, projects, tasks } = getData();
return {
users,
projects,
tasks
};
}
};
</script>

<template>
<ToDo :users="users" :tasks="tasks" :projects="projects" />
</template>

启动应用,To Do List 将渲染并显示示例数据:

在 Vue 应用程序中渲染的带有示例数据的 DHTMLX To Do List

GitHub 上查看完整项目。

跳至主要内容

与 Svelte 集成

提示

在阅读本文档之前,请先熟悉 Svelte 的基本概念和模式。如需温习相关知识,请参阅 Svelte 文档

DHTMLX To Do List 与 Svelte 兼容。以下示例演示如何将两者结合使用。完整项目请参见 GitHub 示例

创建项目

使用脚手架工具创建新的 Svelte 项目并安装依赖项。

信息

在创建新项目之前,请先安装 Vite(可选)和 Node.js

创建 Svelte 项目有以下两种方式:

  • 使用 SvelteKit
  • 不使用 SvelteKit,改用 Svelte with Vite

以下示例使用脚手架创建一个 Svelte + Vite 项目:

npm create vite@latest

详情请参阅相关文章

安装依赖项

将项目命名为 my-svelte-todo-app 并进入应用目录:

cd my-svelte-todo-app

使用包管理器安装依赖项并启动开发服务器。

使用 yarn 运行以下命令:

yarn
yarn start

使用 npm 运行以下命令:

npm install
npm run dev

应用将在本地地址上运行(例如 http://localhost:3000)。

创建 To Do List

停止应用并安装 To Do List 包。

步骤一:安装包

下载 To Do List 试用包 并按照 README 文件中的步骤操作。试用版仅可使用 30 天。

步骤二:创建组件

创建一个 Svelte 组件,将带有 Toolbar 的 To Do List 添加到应用中。在 src/ 目录下,新建一个名为 ToDo.svelte 的文件。

导入源文件

打开 ToDo.svelte,导入 To Do List 的源文件。可选择以下两种导入路径之一:

  • 从本地文件夹安装的 PRO 版本 - 从 dhx-todolist-package 导入
  • 试用版 - 从 @dhx/trial-todolist 导入

以下示例从 PRO 包导入:

ToDo.svelte
<script>
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';
</script>

根据包的不同,源文件可能已被压缩。此时请将 CSS 文件导入为 todo.min.css

以下代码片段从试用包导入:

ToDo.svelte
<script>
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import '@dhx/trial-todolist/dist/todo.css';
</script>

本教程使用试用版本。

设置容器并添加带 Toolbar 的 To Do List

要在页面上显示带 Toolbar 的 To Do List,需为两个组件创建容器并使用构造函数进行初始化。以下示例在 onMount 中绑定容器并初始化组件:

ToDo.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

let toolbar_container, todo_container; // 初始化 To Do List 和 Toolbar 的容器
let todo, toolbar;

onMount(() => {
// 初始化 To Do List 组件
todo = new ToDo(todo_container, {})

// 初始化 Toolbar 组件
toolbar = new Toolbar(toolbar_container, {
api: todo.api, // 提供 To Do List 内部 API
// 其他配置属性
})
});

onDestroy(() => {
todo.destructor(); // 销毁 To Do List
toolbar.destructor(); // 销毁 Toolbar
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>

加载数据

src/ 目录下创建 data.js 文件并向其中添加数据。以下示例导出一个 getData() 函数,该函数返回任务、用户和项目数据:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

打开 App.svelte,导入数据并将其作为 props 传入 <ToDo/> 组件:

App.svelte
<script>
import ToDo from "./ToDo.svelte";
import { getData } from "./data.js";

const { users, tasks, projects } = getData();
</script>

<ToDo {users} {tasks} {projects} />

打开 ToDo.svelte,将传入的 props 应用到 To Do List 配置对象。以下代码片段通过配置传入用户、任务和项目数据:

ToDo.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export let users;
export let tasks;
export let projects;

let toolbar_container, todo_container;
let todo, toolbar;

onMount(() => {
todo = new ToDo(todo_container, {
users,
tasks,
projects,
// 其他配置属性
})

toolbar = new Toolbar(toolbar_container, {
api: todo.api,
// 其他配置属性
})
});

onDestroy(() => {
todo.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>

您也可以在 onMount() 中使用 parse() 方法将数据加载到 To Do List。以下示例在初始化后使用 parse() 加载数据:

ToDo.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export let users;
export let tasks;
export let projects;

let toolbar_container, todo_container;
let todo, toolbar;

onMount(() => {
todo = new ToDo(todo_container, {})

toolbar = new Toolbar(toolbar_container, {
api: todo.api,
// 其他配置属性
})

todo.parse({ tasks, users, projects });
});

onDestroy(() => {
todo.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={todo_container} style="height: calc(100% - 56px);"></div>
</div>

每次调用 parse(data) 都会替换当前数据集。

该组件现在将渲染一个已填充数据的 To Do List。其他可用属性请参见配置概览

处理事件

订阅事件以响应用户操作。请参见完整事件列表

打开 ToDo.svelte 并完善 onMount() 方法。以下代码片段为 add-task 事件添加处理程序:

ToDo.svelte
<script>
// ...
let todo;

onMount(() => {
todo = new ToDo(todo_container, {});

todo.api.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
});

onDestroy(() => {
todo.destructor();
});
</script>

// ...

步骤三:将 To Do List 添加到应用中

要将组件添加到应用中,请打开 App.svelte 并将默认代码替换为以下代码片段:

App.svelte
<script>
import ToDo from "./ToDo.svelte";
import { getData } from "./data.js";

const { users, tasks, projects } = getData();
</script>

<ToDo {users} {tasks} {projects} />

启动应用,To Do List 将渲染并显示示例数据:

在 Svelte 应用程序中渲染的带有示例数据的 DHTMLX To Do List

GitHub 上查看完整项目。

跳至主要内容

与 Angular 集成

提示

在阅读本文档之前,请先熟悉 Angular 的基本概念和模式。如需温习相关知识,请参阅 Angular 文档

DHTMLX To Do List 与 Angular 兼容。以下示例演示如何将两者结合使用。完整项目请参见 GitHub 示例

创建项目

使用脚手架工具创建新的 Angular 项目并安装依赖项。

信息

在创建新项目之前,请先安装 Angular CLINode.js

使用 Angular CLI 创建一个名为 my-angular-todo-app 的新项目,运行以下命令:

ng new my-angular-todo-app
备注

在创建新的 Angular 应用时,请按照本指南的要求禁用服务端渲染(SSR)和静态站点生成(SSG/预渲染)。

该命令会安装所有必要的工具。

安装依赖项

进入新创建的应用目录:

cd my-angular-todo-app

使用 yarn 包管理器安装依赖项并启动开发服务器:

yarn
yarn start

应用将在本地地址上运行(例如 http://localhost:3000)。

创建 To Do List

停止应用并安装 To Do List 包。

步骤一:安装包

下载 To Do List 试用包 并按照 README 文件中的步骤操作。试用版仅可使用 30 天。

步骤二:创建组件

创建一个 Angular 组件,将带有 Toolbar 的 To Do List 添加到应用中。在 src/app/ 目录下,新建 todo 文件夹,并在其中创建 todo.component.ts 文件。

导入源文件

打开 todo.component.ts,导入 To Do List 的源文件。可选择以下两种导入路径之一:

  • 从本地文件夹安装的 PRO 版本 - 从 dhx-todolist-package 导入
  • 试用版 - 从 @dhx/trial-todolist 导入

以下代码片段从 PRO 包导入:

todo.components.ts
import { ToDo, Toolbar } from 'dhx-todolist-package';

以下代码片段从试用包导入:

todo.components.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';

本教程使用试用版本。

设置容器并初始化带 Toolbar 的 To Do List

要在页面上显示带 Toolbar 的 To Do List,需为两个组件设置容器并使用构造函数进行初始化。以下示例定义模板、引用容器,并在 ngOnInit() 内初始化组件:

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist'; 
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo", // 模板名称,在 "app.component.ts" 中以 <todo /> 形式使用
styleUrls: ["./todo.component.css"], // 引入 CSS 文件

template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
// 初始化 Toolbar 的容器
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// 初始化 To Do List 的容器
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
// 初始化 To Do List 组件
this._todo = new ToDo(this.todo_container.nativeElement, {});

// 初始化 Toolbar 组件
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// 其他配置属性
});
}

ngOnDestroy(): void {
this._todo.destructor(); // 销毁 To Do List
this._toolbar.destructor(); // 销毁 Toolbar
}
}

添加样式

导入 CSS 文件以确保 To Do List 正确渲染。在 src/app/todo/ 目录下创建 todo.component.css 文件,并为 To Do List 及其容器添加样式。以下代码片段导入 To Do List 样式并设置布局尺寸:

todo.component.css
/* 导入 To Do List 样式 */
@import "@dhx/trial-todolist/dist/todo.css";

/* 初始页面样式 */
html,
body{
height: 100%;
padding: 0;
margin: 0;
background-color: #f7f7f7;
}

/* To Do List 和 Toolbar 容器的样式 */
.component_container {
height: 100%;
max-width: 800px;
margin: 0 auto;
}

/* To Do List 容器的样式 */
.widget {
height: calc(100% - 56px);
}

加载数据

src/app/todo/ 目录下创建 data.ts 文件并向其中添加数据。以下示例导出一个 getData() 函数,该函数返回任务、用户和项目数据:

data.ts
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

打开 todo.component.ts,导入数据文件,并在 ngOnInit() 方法中将数据属性传入 To Do List 的配置对象。以下代码片段在初始化时应用用户、任务和项目数据:

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo",
styleUrls: ["./todo.component.css"],
template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
const { users, tasks, projects } = getData(); // 初始化数据属性
this._todo = new ToDo(this.todo_container.nativeElement, {
users,
tasks,
projects,
// 其他配置属性
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// 其他配置属性
});
}

ngOnDestroy(): void {
this._todo.destructor();
this._toolbar.destructor();
}
}

您也可以在 ngOnInit() 中使用 parse() 方法将数据加载到 To Do List。以下示例在初始化后使用 parse() 加载数据:

todo.component.ts
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "todo",
styleUrls: ["./todo.component.css"],
template: `<main class = "component_container">
<div #toolbar_container></div>
<div #todo_container class = "widget"></div>
</main>`
})

export class ToDoComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("todo_container", { static: true }) todo_container!: ElementRef;

private _todo!: ToDo;
private _toolbar!: Toolbar;

ngOnInit() {
const { users, tasks, projects } = getData(); // 初始化数据属性
this._todo = new ToDo(this.todo_container.nativeElement, {});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._todo.api,
// 其他配置属性
});

// 通过 parse() 方法应用数据
this._todo.parse({
users,
tasks,
projects
});
}

ngOnDestroy(): void {
this._todo.destructor();
this._toolbar.destructor();
}
}

每次调用 parse(data) 都会替换当前数据集。

该组件现在将渲染一个已填充数据的 To Do List。其他可用属性请参见配置概览

处理事件

订阅事件以响应用户操作。请参见完整事件列表

打开 todo.component.ts 并完善 ngOnInit() 方法。以下代码片段为 add-task 事件添加处理程序:

todo.component.ts
// ...
ngOnInit() {
this._todo = new ToDo(this.todo_container.nativeElement, {});

this._todo.events.on("add-task", (obj) => {
console.log("A new task is added", obj);
});
}

ngOnDestroy(): void {
this._todo.destructor();
}

步骤三:将 To Do List 添加到应用中

要将 ToDoComponent 添加到应用中,请打开 src/app/app.component.ts 并将默认代码替换为以下代码片段:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<todo/>` // 在 "todo.component.ts" 中创建的模板
})
export class AppComponent {
name = "";
}

src/app/ 目录下创建 app.module.ts 文件并注册 ToDoComponent。以下示例声明组件并启动应用:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { ToDoComponent } from "./todo/todo.component";

@NgModule({
declarations: [AppComponent, ToDoComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

最后一步是打开 src/main.ts 并将现有代码替换为以下内容:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

启动应用,To Do List 将渲染并显示示例数据:

在 Angular 应用程序中渲染的带有示例数据的 DHTMLX To Do List

GitHub 上查看完整项目。

跳至主要内容

与 React 集成

提示

在阅读本文档之前,请先熟悉 React 的基本概念和模式。如需温习相关知识,请参阅 React 文档

DHTMLX To Do List 与 React 兼容。以下示例演示如何将两者结合使用。完整项目请参见 GitHub 示例

创建项目

使用脚手架工具创建新的 React 项目并安装依赖项。

信息

在创建新项目之前,请先安装 Vite(可选)和 Node.js

创建一个基础的 React 项目,或使用 React with Vite。以下示例将项目命名为 my-react-todo-app

npx create-react-app my-react-todo-app

安装依赖项

进入新创建的应用目录:

cd my-react-todo-app

使用包管理器安装依赖项并启动开发服务器。

使用 yarn 运行以下命令:

yarn
yarn start

使用 npm 运行以下命令:

npm install
npm start

应用将在本地地址上运行(例如 http://localhost:3000)。

创建 To Do List

停止应用并安装 To Do List 包。

步骤一:安装包

下载 To Do List 试用包 并按照 README 文件中的步骤操作。试用版仅可使用 30 天。

步骤二:创建组件

创建一个 React 组件,将带有 Toolbar 的 To Do List 添加到应用中。在 src/ 目录下,新建一个名为 ToDo.jsx 的文件。

导入源文件

打开 ToDo.jsx,导入 To Do List 的源文件。可选择以下两种导入路径之一:

  • 从本地文件夹安装的 PRO 版本 - 从 dhx-todolist-package 导入
  • 试用版 - 从 @dhx/trial-todolist 导入

以下示例从 PRO 包导入:

ToDo.jsx
import { ToDo, Toolbar } from 'dhx-todolist-package';
import 'dhx-todolist-package/dist/todo.css';

根据包的不同,源文件可能已被压缩。此时请将 CSS 文件导入为 todo.min.css

以下代码片段从试用包导入:

ToDo.jsx
import { ToDo, Toolbar } from '@dhx/trial-todolist';
import "@dhx/trial-todolist/dist/todo.css";

本教程使用试用版本。

设置容器并添加带 Toolbar 的 To Do List

要在页面上显示带 Toolbar 的 To Do List,需为两个组件创建容器并使用构造函数进行初始化。以下示例在 useEffect 中渲染两个容器并初始化组件:

ToDo.jsx
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css"; // 引入 To Do List 样式

export default function ToDoComponent(props) {
let toolbar_container = useRef(); // 初始化 Toolbar 的容器
let todo_container = useRef(); // 初始化 To Do List 的容器

useEffect(() => {
// 初始化 To Do List 组件
const todo = new ToDo(todo_container.current, {});

// 初始化 Toolbar 组件
const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api, // 提供 To Do List 内部 API
// 其他配置属性
});

return () => {
todo.destructor(); // 销毁 To Do List
toolbar.destructor(); // 销毁 Toolbar
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}

添加样式

设置样式以确保 To Do List 正确渲染。使用 index.css 文件为 To Do List 及其容器设置样式。以下示例定义页面的布局尺寸:

index.css
/* 初始页面样式 */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
background-color: #f7f7f7;
}

/* To Do List 和 Toolbar 容器的样式 */
.component_container {
height: 100%;
max-width: 800px;
margin: 0 auto;
}

/* To Do List 容器的样式 */
.widget {
height: calc(100% - 56px);
}

加载数据

src/ 目录下创建 data.js 文件并向其中添加数据。以下示例导出一个 getData() 函数,该函数返回任务、用户和项目数据:

data.js
export function getData() {
const tasks = [
{
id: "temp://1652991560212",
project: "introduction",
text: "Greetings, everyone! \u{1F44B} \nI'm DHTMLX To Do List.",
priority: 1
},
{
id: "1652374122964",
project: "introduction",
text: "You can assign task performers and due dates using the menu.",
assigned: ["user_4", "user_1", "user_2", "user_3"],
due_date: "2033-03-08T21:00:00.000Z",
priority: 2
},
// ...
];
const users = [
{
id: "user_1",
label: "Don Smith",
avatar:
"https://snippet.dhtmlx.com/codebase/data/common/img/02/avatar_61.jpg"
},
// ...
];
const projects = [
{
id: "introduction",
label: "Introduction to DHTMLX To Do List"
},
{
id: "widgets",
label: "Our widgets"
}
];
return { tasks, users, projects };
}

打开 App.js 并导入数据。将数据作为 props 传入 <ToDo/> 组件,如下所示:

App.js
import ToDo from "./ToDo";
import { getData } from "./data";

function App() {
const { tasks, users, projects } = getData();
return <ToDo tasks={tasks} users={users} projects={projects} />;
}

export default App;

打开 ToDo.jsx,将传入的 props 应用到 To Do List 配置对象。以下代码片段通过配置传入用户、任务和项目数据:

ToDo.jsx
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default function ToDoComponent(props) {
let todo_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const todo = new ToDo(todo_container.current, {
users: props.users,
tasks: props.tasks,
projects: props.projects,
// 其他配置属性
});

const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api,
// 其他配置属性
});

return () => {
todo.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}

您也可以在 useEffect() 中使用 parse() 方法将数据加载到 To Do List。以下示例在初始化后使用 parse() 加载数据:

ToDo.jsx
import { useEffect, useRef } from "react";
import { ToDo, Toolbar } from "@dhx/trial-todolist";
import "@dhx/trial-todolist/dist/todo.css";

export default function ToDoComponent(props) {
let todo_container = useRef();
let toolbar_container = useRef();

let tasks = props.tasks;
let users = props.users;
let projects = props.projects;

useEffect(() => {
const todo = new ToDo(todo_container.current, {});

const toolbar = new Toolbar(toolbar_container.current, {
api: todo.api,
// 其他配置属性
});

todo.parse({ tasks, users, projects });

return () => {
todo.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={todo_container} className="widget"></div>
</div>
}

每次调用 parse(data) 都会替换当前数据集。

该组件现在将渲染一个已填充数据的 To Do List。其他可用属性请参见配置概览

处理事件

订阅事件以响应用户操作。请参见完整事件列表

打开 ToDo.jsx 并完善 useEffect() 方法。以下代码片段为 add-task 事件添加处理程序:

ToDo.jsx
// ...
useEffect(() => {
const todo = new ToDo(todo_container.current, {});

todo.api.on("add-task", (obj) => {
console.log("A new task is added", obj);
});

return () => {
todo.destructor();
};
}, []);
// ...

步骤三:将 To Do List 添加到应用中

要将组件添加到应用中,请打开 App.js 并将默认代码替换为以下代码片段:

App.js
import ToDo from "./ToDo";
import { getData } from "./data";

function App() {
const { tasks, users, projects } = getData();
return <ToDo tasks={tasks} users={users} projects={projects} />;
}

export default App;

启动应用,To Do List 将渲染并显示示例数据:

在 React 应用程序中渲染的带有示例数据的 DHTMLX To Do List

GitHub 上查看完整项目。